class Admin::CategoriesController < AdminController
  
  before_action :set_category, only: [:edit, :update, :destroy]

  def new
    @category = Category.new
  end

  def edit
  end

  def create
    @category = Category.new(category_params)
    set_attributes_languages(@category, ['name'])

    respond_to do |format|
      if @category.save
        format.html { redirect_to edit_admin_category_path(@category), notice: 'Category was successfully created.' }
      else
        format.html { render :new }
      end
    end
  end

  def update
    respond_to do |format|
      if @category.update(category_params)
        format.html { redirect_to edit_admin_category_path(@category), notice: 'Category was successfully updated.' }
      else
        format.html { render :edit }
      end
    end
  end

  def destroy
    @category.destroy
    respond_to do |format|
      format.html { redirect_to admin_root_path, notice: 'Category was successfully destroyed.' }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_category
      @category = Category.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def category_params
      params.fetch(:category, {}).permit(:name)
    end
end
