class Admin::ProductBlocksController < AdminController
  
  before_action :set_product_block, only: [:update, :destroy]

  def create
    @product_block = ProductBlock.new(product_block_params)

    respond_to do |format|
      if @product_block.save
        format.html { redirect_to edit_admin_product_path(@product_block.product) }
      else
        format.html {}
      end
    end
  end

  def update
    respond_to do |format|
      if @product_block.update(product_block_params)
        format.html { redirect_to edit_admin_product_path(@product_block.product) }
      else
        format.html {}
      end
    end
  end

  def destroy
    @product_block.destroy
    respond_to do |format|
      format.html { redirect_to edit_admin_product_path(@product_block.product) }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_product_block
      @product_block = ProductBlock.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def product_block_params
      params.fetch(:product_block, {}).permit(
        :price,
        :price_tax,
        :price_type,
        :size_x,
        :size_y,
        :size_z,
        :sale_available,
        :product_id
      )
    end
end