class Admin::ProductImagesController < AdminController
  before_action :set_product_image, only: [:edit, :update, :destroy]

  def edit
    @product = @product_image.product
    @subcategory = @product.subcategory
    @category = @subcategory.category
  end

  def create
    @product_image = ProductImage.new(product_image_params)

    respond_to do |format|
      if @product_image.save
        format.html { redirect_to edit_admin_product_path(@product_image.product), notice: 'Product image was successfully created.' }
      else
        format.html { render :new }
      end
    end
  end

  def update
    respond_to do |format|
      if @product_image.update(product_image_params)
        format.html { redirect_to @product_image, notice: 'Product image was successfully updated.' }
      else
        format.html { render :edit }
      end
    end
  end

  def destroy
    @product_image.destroy
    respond_to do |format|
      format.html { redirect_to edit_admin_product_path(params[:product_id]), notice: 'Product image was successfully destroyed.' }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_product_image
      @product_image = ProductImage.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def product_image_params
      params.fetch(:product_image, {}).permit(
        :product_id,
        :image
      )
    end
end
