class Admin::SubcategoriesController < AdminController
  
  before_action :set_subcategory, only: [:edit, :update, :destroy]
  
  def index
    @category = Category.find(params[:category_id])
    @subcategories = Subcategory.all
  end

  def new
    @category = Category.find(params[:category_id])
    @subcategory = Subcategory.new
  end

  def edit
  end

  def create
    @subcategory = Subcategory.new(subcategory_params)
    set_attributes_languages(@subcategory, ['name'])

    respond_to do |format|
      if @subcategory.save
        format.html { redirect_to edit_admin_subcategory_path(@subcategory), notice: 'Subcategory was successfully created.' }
      else
        format.html { render :new }
      end
    end
  end

  def update
    respond_to do |format|
      if @subcategory.update(subcategory_params)
        format.html { redirect_to edit_admin_subcategory_path(@subcategory), notice: 'Subcategory was successfully updated.' }
      else
        format.html { render :edit }
      end
    end
  end

  def destroy
    @subcategory.destroy
    respond_to do |format|
      format.html { redirect_to admin_root_path, notice: 'Subcategory was successfully destroyed.' }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_subcategory
      @subcategory = Subcategory.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def subcategory_params
      params.fetch(:subcategory, {}).permit(:name, :category_id)
    end
end
