class ApplicationController < ActionController::Base
  protect_from_forgery with: :exception
  
  before_action :set_locale
  
  def after_sign_in_path_for(resource)
    request.env['omniauth.origin'] || stored_location_for(resource) || admin_root_path
  end

  private

    def extract_locale_from_accept_language_header
      request.env['HTTP_ACCEPT_LANGUAGE'].scan(/^[a-z]{2}/).first.to_sym
    end
  
    def set_locale
      I18n.locale = session[:locale] || extract_locale_from_accept_language_header || params[:locale] || I18n.default_locale
      session[:locale] = I18n.locale
    end
end
