class ProductsController < ApplicationController
  
  before_action :set_product, only: [:show]

  def index
    @subcategory = Subcategory.find(params[:subcategory_id])
  end

  def show
    @subcategory = Subcategory.find(@product.subcategory_id)
    @product_blocks = ProductBlock.where(product_id: params[:id])
    @product_images = ProductImage.where(product_id: @product.id)
    @product_blocks_sizes = []
    
    @product_blocks.each do |product_block|
      @product_blocks_sizes << "#{product_block.size_x}x#{product_block.size_y}"
    end

    @product_blocks_sizes = @product_blocks_sizes.uniq.sort
    @product_blocks_sizes_count = @product_blocks_sizes.count
    @product_blocks_grouped = @product_blocks.group_by(&:size_z)
  
    @type_calculation = TypeCalculation.find(@product.type_calculation_id).name
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_product
      @product = Product.find(params[:id])
    end
end
