class SetLanguageController < ApplicationController
  
  def locale_ca
    I18n.locale = :ca
    set_session_and_redirect
  end

  def locale_es
    I18n.locale = :es
    set_session_and_redirect
  end

  private
  
    def set_session_and_redirect
      session[:locale] = I18n.locale
      redirect_to :back
      rescue ActionController::RedirectBackError
        redirect_to :root
    end
end
