class TypeCalculationsController < ApplicationController
  before_action :set_type_calculation, only: [:show, :edit, :update, :destroy]

  # GET /type_calculations
  # GET /type_calculations.json
  def index
    @type_calculations = TypeCalculation.all
  end

  # GET /type_calculations/1
  # GET /type_calculations/1.json
  def show
  end

  # GET /type_calculations/new
  def new
    @type_calculation = TypeCalculation.new
  end

  # GET /type_calculations/1/edit
  def edit
  end

  # POST /type_calculations
  # POST /type_calculations.json
  def create
    @type_calculation = TypeCalculation.new(type_calculation_params)

    respond_to do |format|
      if @type_calculation.save
        format.html { redirect_to @type_calculation, notice: 'Type calculation was successfully created.' }
        format.json { render :show, status: :created, location: @type_calculation }
      else
        format.html { render :new }
        format.json { render json: @type_calculation.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /type_calculations/1
  # PATCH/PUT /type_calculations/1.json
  def update
    respond_to do |format|
      if @type_calculation.update(type_calculation_params)
        format.html { redirect_to @type_calculation, notice: 'Type calculation was successfully updated.' }
        format.json { render :show, status: :ok, location: @type_calculation }
      else
        format.html { render :edit }
        format.json { render json: @type_calculation.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /type_calculations/1
  # DELETE /type_calculations/1.json
  def destroy
    @type_calculation.destroy
    respond_to do |format|
      format.html { redirect_to type_calculations_url, notice: 'Type calculation was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_type_calculation
      @type_calculation = TypeCalculation.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def type_calculation_params
      params.fetch(:type_calculation, {})
    end
end
