module ApplicationHelper

  def sitemap(controller_name, action)

    sitemap_not_found = ['']

    case controller_name

    when 'admin/home'
      case action
      when 'index'
        sitemap_values = sitemap_not_found
      else
        sitemap_values = sitemap_not_found
      end

    when 'admin/categories'
      case action
      when 'new'
        sitemap_values = [sitemap_element('Crear categoria')]
      when 'edit'
        sitemap_values = [sitemap_element(@category.name)]
      else
        sitemap_values = sitemap_not_found
      end

    when 'admin/subcategories'
      case action
      when 'new'
        sitemap_values = [
          sitemap_element(link_to(@category.name, edit_admin_category_path(@category))),
          sitemap_element('Crear subcategoria')
        ]
      when 'edit'
        sitemap_values = [
          sitemap_element(link_to(@subcategory.category.name, edit_admin_category_path(@subcategory.category))),
          sitemap_element(@subcategory.name)
        ]
      else
        sitemap_values = sitemap_not_found
      end

    when 'admin/products'
      case action
      when 'new'
        sitemap_values = [
          sitemap_element(link_to(@category.name, edit_admin_category_path(@category))),
          sitemap_element(link_to(@category.name, edit_admin_category_path(@category))),
          sitemap_element('Crear producte')
        ]
      when 'edit'
        sitemap_values = [
          sitemap_element(link_to(@category.name, edit_admin_category_path(@category))),
          sitemap_element(link_to(@subcategory.name, edit_admin_subcategory_path(@subcategory))),
          sitemap_element(@product.name)
        ]
      else
        sitemap_values = sitemap_not_found
      end

    when 'admin/product_images'
      case action
      when 'edit'
        sitemap_values = [
          sitemap_element(link_to(@category.name, edit_admin_category_path(@category))),
          sitemap_element(link_to(@subcategory.name, edit_admin_subcategory_path(@subcategory))),
          sitemap_element(link_to(@product.name, edit_admin_product_path(@product))),
          sitemap_element(@product_image.id)
        ]
      else
        sitemap_values = sitemap_not_found
      end
      
    when 'subcategories'
      case action
      when 'index'
        sitemap_values = [
          sitemap_element(@category.name)
        ]
      else
        sitemap_values = sitemap_not_found
      end
    when 'products'
      case action
      when 'index'
        sitemap_values = [
          sitemap_element(link_to(@subcategory.category.name, subcategories_path(category_id: @subcategory.category_id))),
          sitemap_element(@subcategory.name)
        ]
      when 'show'
        sitemap_values = [
          sitemap_element(link_to(@subcategory.category.name, subcategories_path(category_id: @subcategory.category_id))),
          sitemap_element(link_to(@subcategory.name, products_path(subcategory_id: @subcategory.id))),
          sitemap_element(@product.name)
        ]
      else
        sitemap_values = sitemap_not_found
      end
    else
      sitemap_values = sitemap_not_found
    end

    if controller_name.include?("admin/")
      levels = sitemap_values.inject([content_tag(:li, link_to('Admin', '/admin'))], :<<)
    else
      levels = sitemap_values.inject([content_tag(:li, link_to('Home', '/'))], :<<)
    end
    
    levels
  end

  def sitemap_element(content, options = {})
    content_tag(:li, content, options)
  end
end
