    class Product < ApplicationRecord

  # Validations
  validates :name, presence: true

  # Actions
  before_save :prepare_save

  # Translations
  translates :name, :description

  # Associations
  belongs_to :subcategory
  has_many :product_blocks, :dependent => :destroy
  has_many :product_images, :dependent => :destroy
  has_one :type_calculation

  has_attached_file :image, styles: { medium: "300x300", thumb: "100x100" }
  validates_attachment_content_type :image, content_type: /\Aimage\/.*\Z/

  def prepare_save
    self.category_id = Subcategory.find(self.subcategory_id).category_id
  end
end
