class ProductBlock < ApplicationRecord

  # Associations
  belongs_to :product

  # Actions
  before_save :prepare_save

  # Variables
  TAX = 1.21

  def prepare_save

    # Calculate total price
    type_calculation = TypeCalculation.find(self.product.type_calculation_id).name.to_sym

    case type_calculation
    when :ml
      size_x = self.size_x.to_f / 1000
      self.price = (size_x * self.price_type).round(2)
    when :m2
      size_x = self.size_x.to_f / 1000
      size_y = self.size_y.to_f / 1000
      self.price = ((size_x * size_y) * self.price_type).round(2)
      self.size = "#{self.size_x}x#{self.size_y}"
    when :m3
      size_x = self.size_x.to_f / 1000
      size_y = self.size_y.to_f / 1000
      size_z = self.size_z.to_f / 1000
      self.price = ((size_x * size_y * size_z) * self.price_type).round(2)
    else
      self.price = self.price_type
    end

    self.price_tax = (self.price * ProductBlock::TAX).round(2)
  end
end
