class CreateProducts < ActiveRecord::Migration[5.0]
  def change
    
    create_table :products do |t|
      t.string :name_catalan, index: true
      t.string :name_spanish, index: true
      t.string :description_catalan, index: true
      t.string :description_spanish, index: true
      t.boolean :active, default: false
      t.integer :type_calculation_id
      t.integer :subcategory_id, index: true
      t.timestamps
    end

    create_table :type_calculations do |t|
      t.string :name
      t.timestamps
    end

    create_table :product_blocks do |t|
      t.float :price
      t.float :price_tax
      t.float :price_unit
      t.float :price_ml
      t.float :price_m2
      t.float :price_m3
      t.float :price_u
      t.integer :size_x
      t.integer :size_y
      t.integer :size_z
      t.integer :product_id, index: true
      t.boolean :sale_available, default: false
      t.timestamps
    end
  end
end
