class RemoveLanguagestoProducts < ActiveRecord::Migration[5.0]
  def change
    remove_column :products, :name_catalan, :string
    remove_column :products, :name_spanish, :string
    remove_column :products, :description_catalan, :string
    remove_column :products, :description_spanish, :string
    add_column :products, :name, :string
    add_column :products, :description, :string
    remove_column :subcategories, :name_catalan, :string
    remove_column :subcategories, :name_spanish, :string
    add_column :subcategories, :name, :string
    remove_column :categories, :name_catalan, :string
    remove_column :categories, :name_spanish, :string
    add_column :categories, :name, :string

    reversible do |dir|
      dir.up do
        Product.create_translation_table! :name => { :type => :string, :null => false, :default => 'Default name' },
          :description => :text
        Subcategory.create_translation_table! :name => { :type => :string, :null => false, :default => 'Default name' }
        Category.create_translation_table! :name => { :type => :string, :null => false, :default => 'Default name' }
      end

      dir.down do
        Product.drop_translation_table!
        Subcategory.drop_translation_table!
        Category.drop_translation_table!
      end
    end
  end
end