require 'rails_helper'

RSpec.describe ProductBlock, :type => :model do
  
  describe 'product with type calculation unit' do

    it 'should create with valid attributes' do
      product_block = create(:product_block_unit)
    
      expect(ProductBlock.count).to eq 1
      expect(product_block.price_unit.present?).to be true
    end

    it 'should has a product parent' do
      product_block = create(:product_block_unit)
      expect(product_block.product.present?).to be true
    end
  end

  describe 'product with type calculation ml' do

    it 'should create with valid attributes' do
      product_block = create(:product_block_ml)
      
      # Calculation price
      size_x = product_block.size_x.to_f / 1000
      price = (size_x * product_block.price_ml).round(2)
    
      expect(ProductBlock.count).to eq 1
      expect(product_block.price_ml.present?).to be true
      expect(product_block.price).to eq price
    end
  end

  describe 'product with type calculation m2' do

    it 'should create with valid attributes' do
      product_block = create(:product_block_m2)
      
      # Calculation price
      size_x = product_block.size_x.to_f / 1000
      size_y = product_block.size_y.to_f / 1000
      price = ((size_x * size_y) * product_block.price_m2).round(2)
    
      expect(ProductBlock.count).to eq 1
      expect(product_block.price_m2.present?).to be true
      expect(product_block.price).to eq price
    end
  end

  describe 'product with type calculation m3' do

    it 'should create with valid attributes' do
      product_block = create(:product_block_m3)
      
      # Calculation price
      size_x = product_block.size_x.to_f / 1000
      size_y = product_block.size_y.to_f / 1000
      size_z = product_block.size_z.to_f / 1000
      price = ((size_x * size_y * size_z) * product_block.price_m3).round(2)
    
      expect(ProductBlock.count).to eq 1
      expect(product_block.price_m3.present?).to be true
      expect(product_block.price).to eq price
    end
  end
end