require 'rails_helper'

RSpec.describe Product, :type => :model do
  
  it 'should create with valid attributes' do
    create(:product_m2)
    expect(Product.count).to eq 1
  end
  
  it 'should not create without all language names' do
    Product.create
    expect(Product.count).to eq 0
  end

  it 'should not create without category association' do
    Product.create(name_catalan: 'a', name_spanish: 'b')
    expect(Product.count).to eq 0
  end

  it 'should belongs to one subcategory' do
    product = create(:product_m2)
    expect(product.subcategory.present?).to be true
  end
end