require 'rails_helper'

RSpec.describe Subcategory, :type => :model do
  
  it 'should create with valid attributes' do
    create(:subcategory)
    expect(Subcategory.count).to eq 1
  end
  
  it 'should not create without all language names' do
    Subcategory.create
    expect(Subcategory.count).to eq 0
  end

  it 'should not create without category association' do
    Subcategory.create(name_catalan: 'a', name_spanish: 'b')
    expect(Subcategory.count).to eq 0
  end

  it 'should belongs to one category' do
    subcategory = create(:subcategory)
    expect(subcategory.category.present?).to be true
  end
end