require "rails_helper"

RSpec.describe ProductBlocksController, type: :routing do
  describe "routing" do

    it "routes to #index" do
      expect(:get => "/product_blocks").to route_to("product_blocks#index")
    end

    it "routes to #new" do
      expect(:get => "/product_blocks/new").to route_to("product_blocks#new")
    end

    it "routes to #show" do
      expect(:get => "/product_blocks/1").to route_to("product_blocks#show", :id => "1")
    end

    it "routes to #edit" do
      expect(:get => "/product_blocks/1/edit").to route_to("product_blocks#edit", :id => "1")
    end

    it "routes to #create" do
      expect(:post => "/product_blocks").to route_to("product_blocks#create")
    end

    it "routes to #update via PUT" do
      expect(:put => "/product_blocks/1").to route_to("product_blocks#update", :id => "1")
    end

    it "routes to #update via PATCH" do
      expect(:patch => "/product_blocks/1").to route_to("product_blocks#update", :id => "1")
    end

    it "routes to #destroy" do
      expect(:delete => "/product_blocks/1").to route_to("product_blocks#destroy", :id => "1")
    end

  end
end
